/*
	====================================
	========	ADMIN KNIFE		========
	====================================
	========	VERSION 2.0.1a	========
	====================================
	========	vk.com/plmods	========
	====================================
	========	by OverGame		========
	====================================
*/

#include amxmodx
#include hamsandwich
#include fakemeta_util

#define PL_NAME						"Admin Knife"
#define PL_VERSION					"2.0.1a"
#define PL_AUTHOR					"OverGame"

enum CVARS_DATA
{
	CVAR_VIEW,
	CVAR_PLAYER,
	CVAR_LEVEL
};
new g_iCvars[CVARS_DATA], g_iKnife[33];

public plugin_init()
{
	register_plugin(PL_NAME, PL_VERSION, PL_AUTHOR);
	
	register_clcmd("admin_knife", "ClCmd_aKnife");
	register_clcmd("say /aknife", "ClCmd_aKnife");
	register_clcmd("say_team /aknife", "ClCmd_aKnife");
	
	register_forward(FM_PlayerPreThink, "FM_PreThink");
	RegisterHam(Ham_Item_Deploy, "weapon_knife", "Ham_Knife_Deploy", true);
}

public plugin_precache()
{
	g_iCvars[CVAR_VIEW] = register_cvar("ae_viewmodel", "");
	g_iCvars[CVAR_PLAYER] = register_cvar("ae_weaponmodel", "");
	g_iCvars[CVAR_LEVEL] = register_cvar("ae_level", "");
	
	new szCfgDir[96];
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	server_cmd("exec %s/aknife.cfg", szCfgDir);
	
	engfunc(EngFunc_PrecacheModel, ae_get_string(g_iCvars[CVAR_VIEW]));
	engfunc(EngFunc_PrecacheModel, ae_get_string(g_iCvars[CVAR_PLAYER]));
}

public Ham_Knife_Deploy(weapon)
{
	new client = get_pdata_cbase(weapon, 41, 4);
	
	if(ae_user_valid(client))
		ae_set_user_knife(client);
}

public client_putinserver(client)
	g_iKnife[client] = ae_user_level(client);

public ClCmd_aKnife(client)
{
	if(!ae_user_valid(client) || !ae_user_level(client))
		return PLUGIN_HANDLED;
	
	g_iKnife[client] = g_iKnife[client] ? false : true;
	
	if(g_iKnife[client])
		ae_set_user_knife(client, true);
	
	return PLUGIN_HANDLED;
}

public FM_PreThink(client)
{
	if(ae_user_valid(client) && g_iKnife[client])
	{
		set_pev(client, pev_fuser2, 0.0);
		new button = pev(client, pev_button);
		
		if(button & IN_JUMP)
		{
			new flags = pev(client, pev_flags);
			
			if(flags & FL_ONGROUND && flags|FL_WATERJUMP && pev(client, pev_waterlevel) < 2)
			{
				new Float:velocity[3];
				pev(client, pev_velocity, velocity);
				velocity[2] += 260.0;
				
				set_pev(client, pev_velocity, velocity);
				set_pev(client, pev_gaitsequence, 6);
			}
		}
	}
}

bool: ae_user_valid(client)
{
	if(!is_user_connected(client) || !is_user_alive(client))
		return false;
	
	return true;
}

bool: ae_user_level(client)
{
	new strflags[32], flags = get_user_flags(client);
	get_flags(flags, strflags, 31);
	
	if(contain(strflags, ae_get_string(g_iCvars[CVAR_LEVEL])) == -1)
		return false;
	
	return true;
}

stock ae_set_user_knife(client, change = false)
{
	if(change) client_cmd(client, "weapon_knife");
	
	if(g_iKnife[client])
	{
		set_pev(client, pev_viewmodel2, ae_get_string(g_iCvars[CVAR_VIEW]));
		set_pev(client, pev_weaponmodel2, ae_get_string(g_iCvars[CVAR_PLAYER]));
	}
	else
		return false;
	
	return true;
}

stock ae_get_string(cvar)
{
	new string[256];
	get_pcvar_string(cvar, string, 255);
	
	return string;
}